@echo off

rem FILE: dspwin.bat            Copyright (c), Symmetric Research, 1998
rem
rem This batch file automatically starts the DSPMON monitor in its 50
rem line VGA mode.
rem
rem It checks for a base .dso filename specified on the DOS command
rem line.  If one is found, it will also check for an associated .dss
rem symbol table.
rem
rem This file is intended only as an example.  You should develop batch
rem files that meet your own application needs.  Executing dspmon with no
rem command line arguments gives a help screen on its options.
rem
rem
rem




rem
rem Make sure only one command line argument is specified.
rem

if not "%2" == "" goto error



rem
rem Check for a base filename specified on the DOS command line.
rem

if "%1" == "" goto no_file

if not exist %1.dso goto error
if not exist %1.dss goto no_symbols

goto full_start




rem
rem Start DSPMON with both a .dso object file and .dss symbol table.
rem

:full_start

dspmon /50 %1.dso %1.dss
goto return



rem
rem Start DSPMON without a .dss symbol table.
rem

:no_symbols

dspmon /50 %1.dso
goto return



rem
rem Start DSPMON in the 50 line mode without any input files. 
rem

:no_file

dspmon /50
goto return



rem
rem Give the user an error message.
rem

:error

echo Illegal dspwin.bat command line ...
echo.
echo    USAGE: dspwin [filename]       with no .dso extension

goto return



rem
rem Return to DOS.
rem

:return

echo on